#ifndef MAIN_H
#define MAIN_H

// --- Personalized types -------------------------------------------------------

// Constantes de projection
typedef struct {
   double a;       // Demi grand axe
   double b;       // Demi petit axe
   double C;       // Constante de la projection (en m)
   double e;       // Premiere excentricite de l'ellipsoide
   double f;       // Aplatissement
   double lambda0; // Longitude du meridien central (en rad)
   double n;       // Exposant de la projection
   double Xs, Ys;  // Coordonnees en projection du pole (en m)
   vector T;       // Vecteur de translation
   double D;       // facteur
   vector R;       // Vecteur de rotation
} cstes_projection;

// Donnees de la session
typedef struct {
   unsigned int sysg;  // 0: WGS84; 1: NTF; 2: RGF93
   unsigned int proj;  // 0: none; 1: LbI; 2: LbII; 3: LbIIe; 4: LbIII; 5: LbIV
   unsigned int coord; // 0: cartesiennes; 1: geographiques; 2: planes

   cstes_projection cstes;
} data;

// --- Prototypes of the functions ----------------------------------------------

void help(void);
void ignore(const char *str);
void version(void);
void wrong(const char *str);

#endif
