#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <ctype.h>

#include "misc.h"

// --- Mathematical functions --------------------------------------------------

double deg2rad(double val) {
   return val*(pi/180.0);
}

double gr2deg(double val) {
   return val*(180.0/200.0);
}

double sq(double val) {
   return val*val;
}

double cube(double val) {
   return val*val*val;
}

// --- Text format functions ---------------------------------------------------

int deg2dmm(char *result, double val, unsigned short c) {
   char *buffer=(char *)malloc(32+1);
   char dir;
   double min, sec;

   switch(c) {
      case 0 : dir=(val > 0) ? 'N' : 'S'; break; // lat
      case 1 : dir=(val > 0) ? 'E' : 'W'; break; // lon
      default: dir='?'; break;
   }

   val=fabs(val);
   min=(val-((int)(val)))*60.0;
   sec=(min-((int)(min)))*60.0;

   sprintf(buffer, "%2d%2d'%6.3lf\"%c", (int)(val), (int)(min), sec, dir);

   return 0;
}

void strtolower(char *str, char *src) {
   unsigned int i=0;

   for(i=0; i<strlen(src); i++) {
      str[i]=tolower(src[i]);
   }
}

int substr(char *str, const char *src, unsigned int start, unsigned int length) {
   unsigned int len=strlen(src);

   if((start < 0) || // underflow
      (start > (len-1)) || // overflow
      ((start+length) > len)) { // (-1) <= start = current position in string | range=[0; strlen()-1]
      strcpy(str, "");

      return -1; // ERROR: ?
   } else if((start == 0) && (length == len)) {
      strcpy(str, src);

      return length;
   } else {
      unsigned int i=start;
      int n=0;

      for(i=start; i < (start+length); i++) {
         str[n]=src[i];
         n++;
      }

      return n;
   }
}
